
require("lib/SECS")
require("Entity")
require("WallTile")
gamestate = require ("lib/hump/gamestate")
Collider = require ("lib/hardoncollider")
polygon = require ("lib/hardoncollider.polygon")
shapes = require ("lib/hardoncollider.shapes")
-- Game states here
level1 = gamestate.new() -- I added a gamestate libary that should help
-- Game states
-- Tile Stuff here
tile = {}
map_w = 20 	
map_h = 15
map_x = 0
map_y = 0
map_offset_x = -32
map_offset_y = -32
tile_w = 32 -- This times map_w = 640
tile_h = 32 -- This times map_h = 480
wallTilesP1 = {} -- This one is for the tile class
wallTiles = {}
--Tile Stuff
debug1 = "Welcome the the game"
function love.load(dt)

	HC = Collider.new(100, on_collide, on_stop_collide) -- I don't know what the 100 means 
    gamestate.registerEvents() -- Calling the GameStates
    gamestate.switch(level1) -- Ofcourse this will eventually be the into or menu
	--The code is really rough right now I'm sure there are ways to clear it up a lot better and to make it more efficient
	
end

function love.draw()

love.graphics.setColor(255,255,255)
love.graphics.print( debug1 , 100, 10, 0, 1.5,1.5)

end

function love.update()
HC:update()

end

function initTiles()

	for y=1, map_h do
		for x=1, map_w do
			if map[y+map_y][x+map_x] == 1 then -- if it's a wall tile
			px = (x*tile_w)+map_offset_x
			py = (y*tile_h)+map_offset_y
			table.insert(wallTilesP1, polygon(px,py,px + 34,py,px,py + 34, px + 34, py, px + 34, py +34, px, py + 34)) -- Now we have all our block polygons, let us combine the colliding ones together
			end
		end
	end
	for i = 1, #wallTilesP1, 1 do
		for z = 1, #wallTilesP1, 1 do
			if wallTilesP1[i] ~= wallTilesP1[z] then
			debug1 = "Step 1"
				if wallTilesP1[i]:mergedWith(wallTilesP1[z]) ~= nil then
					debug1 = "WE HAS COLLIDING SHAPES!!"
					table.insert(wallTilesP1,  wallTilesP1[i]:mergedWith(wallTilesP1[z]))
					table.remove(wallTilesP1,z)
					table.remove(wallTilesP1,i)
				end
			end
		end
	end
	for j = 1, #wallTilesP1,1 do
		coords = wallTilesP1[j]
		table.insert(wallTiles,#wallTiles + 1, HC:addPolygon(coords))
	end
		
end

function drawTiles()

	--for i = 1, #wallTiles, 1 do
		--wallTiles[i]:draw('fill')
	--end
	for i = 1, #wallTilesP1, 1 do
	love.graphics.setColor(30,255,30)
	love.graphics.polygon('line',wallTilesP1[i]:unpack())
	end
	
end

function updateTiles(dt)

	for i = 1, #wallTiles, 1 do
		wallTiles[i]:update(dt)
	end
	
end


function level1:init()
	entity = Entity:new()
	entity:init(0,0)
	map={ -- My friends, we have a tile map for level1
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	
	}

	initTiles() -- Initiating the tiles when the level initiallizes
end

function level1:enter() 

-- Runs every time it enters the game state.

end

function level1:update(dt)

	entity:update(dt)
	--updateTiles(dt)

end
function level1:draw()

	drawTiles() -- Draw each tile!
	entity:draw()

end

function on_collide(dt, shape_one, shape_two, mtv_x, mtv_y)
if shape_one == ECI then -- If it's the entity 
 -- For now I will assume the entity is on the tile
entity.colliding = true
end
end

function on_stop_collide(dt, shape_one, shape_two)
if shape_one == ECI then -- if it's the entity
entity.colliding = false
end
end

				--table.insert(wallTiles, #wallTiles + 1, WallTile:new()) -- Add the tile to the wall tile table
				--wallTiles[#wallTiles]:init((x*tile_w)+map_offset_x,(y*tile_h)+map_offset_y ) -- Initiallize the WallTile instance
			    --table.insert(wallTilesC,#wallTilesC + 1,(HC:addRectangle((x*tile_w)+map_offset_x, (y*tile_h)+map_offset_y, 31, 31) )) -- Insert a hardoncollider rectangle
